'use strict';const PropTypes=require('prop-types'),React=require('react'),ReactDnD=require('react-dnd'),ReactDnDHTML5Backend=require('react-dnd-html5-backend'),ReactDOM=require('react-dom'),shapeup=require('shapeup'),MachineViewAddMachine=require('./add-machine/add-machine'),MachineViewColumn=require('./column/column'),MachineViewMachine=require('./machine/machine'),MachineViewScaleUp=require('./scale-up/scale-up'),MachineViewUnplacedUnit=require('./unplaced-unit/unplaced-unit'),SvgIcon=require('../svg-icon/svg-icon'),GenericButton=require('../generic-button/generic-button');class MachineView extends React.Component{constructor(a){super(a),this.state={containerSort:'name',machineSort:'name',placingUnit:null,showAddMachine:!1,showConstraints:!0,showScaleUp:!1}}componentDidMount(){this.selectMachine(this.props.machine||this._getFirstMachineId(this.props.dbAPI.machines))}componentWillReceiveProps(a){const b=this._getSelected();let c=b.container||b.machine;c&&!this.props.dbAPI.machines.getById(c)&&this.selectMachine(this._getFirstMachineId(a.dbAPI.machines))}_getFirstMachineId(a){const b=a.filterByParent();return 0===b.length?null:b[0].id}_removeUnit(a){this.props.modelAPI.removeUnits([a])}_dropUnit(a,b,c){if(b)this.props.modelAPI.placeUnit(a,b);else{var d={};'machine'===c?d.showAddMachine=!0:d.showAddContainer=!0,d.placingUnit=a,this.setState(d)}}_openStore(){this.props.changeState({store:''})}_generateUnplacedUnits(){const a=this.props;let b=a.dbAPI.units.filterByMachine();if(b=b.filter((b)=>{const c=a.dbAPI.applications.getById(b.service);if(!c.get('subordinate'))return b}),0===b.length){var c,d;return 0===a.dbAPI.applications.size()?d=React.createElement('div',null,React.createElement('p',null,'Unplaced units will appear here. Drag and drop them to customise your deployment.'),React.createElement('span',{className:'link',onClick:this._openStore.bind(this)},'Add applications to get started')):(c='task-done_16',d='You have placed all of your units'),React.createElement('div',{className:'machine-view__column-onboarding'},c?React.createElement(SvgIcon,{name:c,size:'16'}):null,d)}const e=[],f=this.state;let g;return(f.showAddMachine||f.showAddContainer)&&(g=f.placingUnit),b.forEach((b)=>{const c=a.dbAPI.applications.getById(b.service);if(!(g&&b.id===g.id)){const d=MachineViewUnplacedUnit.DecoratedComponent.propTypes;e.push(React.createElement(MachineViewUnplacedUnit,{acl:a.acl.reshape(d.acl),dbAPI:a.dbAPI.reshape(d.dbAPI),key:b.id,modelAPI:a.modelAPI.reshape(d.modelAPI),sendAnalytics:a.sendAnalytics,series:a.series,unitAPI:{icon:c.get('icon')||'',removeUnit:this._removeUnit.bind(this),selectMachine:this.selectMachine.bind(this),unit:b}}))}}),React.createElement('div',null,React.createElement('div',{className:'machine-view__auto-place'},React.createElement(GenericButton,{action:a.modelAPI.autoPlaceUnits,disabled:a.acl.isReadOnly(),type:'inline-neutral'},'Auto place'),React.createElement('p',null,'You can also drag and drop unplaced units to customise your deployment.')),React.createElement('ul',{className:'machine-view__list'},e))}_generateScaleUp(){if(this.state.showScaleUp){const a=this.props,b=MachineViewScaleUp.propTypes;return React.createElement(MachineViewScaleUp,{acl:a.acl.reshape(b.acl),dbAPI:a.dbAPI.reshape(b.dbAPI),toggleScaleUp:this._toggleScaleUp.bind(this)})}}_scrollToMachine(a,b=!1){const c=ReactDOM.findDOMNode(b?this.refs.containersColumn:this.refs.machinesColumn),d=c.querySelector('.machine-view__column-content'),e=ReactDOM.findDOMNode(this.refs[`${b?'container':'machine'}-${a}`]);d&&e&&(d.scrollTop=e.offsetTop-d.offsetTop)}selectMachine(a,b=!0){if(null!==a){if(b){const b=this._getSelected(a);this._scrollToMachine(b.machine,!1),b.container&&this._scrollToMachine(b.container,!0)}this.props.changeState({gui:{machines:a}})}}_getSelected(a){a||(a=this.props.machine);let b={machine:null,container:null};if(a){const c=this.props.parseMachineName(a);b.machine=c.parentId||c.number,b.container=c.parentId?a:null}return b}_generateMachines(){if(this.state.showAddMachine)return;const a=this.props,b=a.dbAPI.machines.filterByParent(),c=this._sortMachines(b,this.state.machineSort);let d;if(0===c.length)return React.createElement('div',{className:'machine-view__column-onboarding'},React.createElement('p',null,'Use machine view to:'),React.createElement('ul',null,React.createElement('li',null,'Create machines'),React.createElement('li',null,'Create containers'),React.createElement('li',null,'Customise placement'),React.createElement('li',null,'Scale up your model'),React.createElement('li',null,'Manually place new units'),React.createElement('li',null,'Colocate applications')),React.createElement('span',{className:'link',onClick:this._addMachine.bind(this),role:'button',tabIndex:'0'},'Add machine'));1===c.length&&(d=React.createElement('div',{className:'machine-view__column-onboarding'},'Drag and drop unplaced units onto your machines and containers to customise your deployment.'));const e=[],f=MachineViewMachine.DecoratedComponent.propTypes,g=a.acl.reshape(f.acl),h=a.dbAPI.reshape(f.dbAPI),i=a.modelAPI.reshape(f.modelAPI);return c.forEach((b)=>{const c=this._getSelected().machine;e.push(React.createElement(MachineViewMachine,{acl:g,dbAPI:h,dropUnit:this._dropUnit.bind(this),key:b.id,machineAPI:{generateMachineDetails:a.generateMachineDetails,machine:b,series:a.series,selectMachine:this.selectMachine.bind(this),selected:c===b.id},modelAPI:i,parseConstraints:a.parseConstraints,ref:`machine-${b.id}`,sendAnalytics:a.sendAnalytics,showConstraints:this.state.showConstraints||b.id===c,type:'machine'}))}),React.createElement('div',null,d,React.createElement('ul',{className:'machine-view__list'},e))}_generateContainers(){const a=this._getSelected(),b=a.machine;if(!b)return;const c=this.props,d=c.dbAPI.machines.filterByParent(b),e=this._sortMachines(d,this.state.containerSort),f=c.dbAPI.machines.getById(b);if(!f)return;e.unshift({commitStatus:f.commitStatus,deleted:f.deleted,displayName:'Root container',id:b,root:!0});const g=MachineViewMachine.DecoratedComponent.propTypes,h=[];return e.forEach((b)=>{h.push(React.createElement(MachineViewMachine,{acl:c.acl.reshape(g.acl),dbAPI:c.dbAPI.reshape(g.dbAPI),dropUnit:this._dropUnit.bind(this),key:b.id,machineAPI:{machine:b,removeUnit:this._removeUnit.bind(this),selected:a.container?a.container===b.id:a.machine===b.id,selectMachine:this.selectMachine.bind(this)},modelAPI:c.modelAPI.reshape(g.modelAPI),parseConstraints:c.parseConstraints,ref:`container-${b.id}`,sendAnalytics:c.sendAnalytics,type:'container'}))}),React.createElement('ul',{className:'machine-view__list'},h)}_addMachine(){this.setState({showAddMachine:!0})}_closeAddMachine(){this.setState({placingUnit:null,showAddMachine:!1})}_generateAddMachine(){if(this.state.showAddMachine){const a=this.props,b=MachineViewAddMachine.propTypes;return React.createElement(MachineViewAddMachine,{acl:a.acl.reshape(b.acl),close:this._closeAddMachine.bind(this),modelAPI:a.modelAPI.reshape(b.modelAPI),selectMachine:this.selectMachine.bind(this),series:a.series,unit:this.state.placingUnit})}}_addContainer(){var a=this._getSelected().machine;let b=!1;if(a){const c=this.props.dbAPI.machines.getById(a);b=c.deleted}a&&!b&&this.setState({showAddContainer:!0})}_closeAddContainer(){this.setState({placingUnit:null,showAddContainer:!1})}_generateAddContainer(){if(this.state.showAddContainer){const a=this.props,b=MachineViewAddMachine.propTypes;return React.createElement(MachineViewAddMachine,{acl:a.acl.reshape(b.acl),close:this._closeAddContainer.bind(this),modelAPI:a.modelAPI.reshape(b.modelAPI),parentId:this._getSelected().machine,series:a.series,unit:this.state.placingUnit})}}_generateMachinesTitle(){const a=this.props.dbAPI.machines.filterByParent();return`${this.props.dbAPI.modelName} (${a.length})`}_toggleConstraints(){this.setState({showConstraints:!this.state.showConstraints})}_toggleScaleUp(){this.setState({showScaleUp:!this.state.showScaleUp})}_generateContainersTitle(){const a=this.props.dbAPI;var b=this._getSelected().machine;let c=0,d=0;if(b){const e=a.machines.filterByParent(b),f=a.units.filterByMachine(b);c=e.length,d=f.length}const e=1===c?'':'s',f=1===d?'':'s';return`${c} container${e}, `+`${d} unit${f}`}_sortMachines(a,b){var c=this._getSortMethod(b);return a.sort(function(d,a){var b=c(d),e=c(a);if(b==e)return 0;return b>e?1:b<e?-1:void 0})}_setSortMethod(a,b){var c={};b?c.containerSort=a:c.machineSort=a,this.setState(c)}_getSortMethod(a){let b,c=0;const d=this.props.dbAPI.units;return'units'===a?b=function(a){var b=d.filterByMachine(a.id);return b&&(c=b.length),-c}:'name'===a?b=function(a){for(var b=a.displayName,c=0;c<50-b.length;c+=1)b='0'+b;return b}:'disk'===a?b=function(a){return a.hardware&&(c=a.hardware.disk),-c}:'ram'===a?b=function(a){return a.hardware&&(c=a.hardware.mem),-c}:'cpu'===a?b=function(a){return a.hardware&&(c=a.hardware.cpuPower),-c}:'application'===a?b=function(a){var b=d.filterByMachine(a.id);if(b){var e={};b.forEach(function(a){e[a.service]=!0}),c=Object.keys(e)}return c}:'applications'===a?b=function(a){var b=d.filterByMachine(a.id);if(b){var e={};b.forEach(function(a){e[a.service]=!0}),c=Object.keys(e).length}return-c}:'size'===a?b=function(a){return a.hardware&&(c=a.hardware.mem+a.hardware.disk),-c}:void 0,b}render(){const a=this.props,b=a.acl.isReadOnly(),c=[{label:'Add machine',action:!b&&this._addMachine.bind(this)},{label:this.state.showConstraints?'Hide constraints':'Show constaints',action:this._toggleConstraints.bind(this)},{label:'Sort by:'},{label:'Name',id:'name',action:this._setSortMethod.bind(this,'name')},{label:'No. applications',id:'applications',action:this._setSortMethod.bind(this,'applications')},{label:'No. units',id:'units',action:this._setSortMethod.bind(this,'units')},{label:'Disk',id:'disk',action:this._setSortMethod.bind(this,'disk')},{label:'RAM',id:'ram',action:this._setSortMethod.bind(this,'ram')},{label:'CPU',id:'cpu',action:this._setSortMethod.bind(this,'cpu')}];var d=[{label:'Add container',action:!b&&(this._getSelected().machine?this._addContainer.bind(this):null)},{label:'Sort by:'},{label:'Name',id:'name',action:this._setSortMethod.bind(this,'name',!0)},{label:'No. units',id:'units',action:this._setSortMethod.bind(this,'units',!0)},{label:'Applications',id:'applications',action:this._setSortMethod.bind(this,'application',!0)}];const e={action:this._toggleScaleUp.bind(this),disabled:0===a.dbAPI.applications.size(),toggleOn:this.state.showScaleUp},f=MachineViewColumn.DecoratedComponent,g=a.acl.reshape(f.propTypes.acl);return React.createElement('div',{className:'machine-view'},React.createElement('div',{className:'machine-view__content'},React.createElement(MachineViewColumn,{acl:g,droppable:!1,sendAnalytics:a.sendAnalytics,title:'New units',toggle:e},this._generateScaleUp(),this._generateUnplacedUnits()),React.createElement(MachineViewColumn,{acl:g,activeMenuItem:this.state.machineSort,droppable:!0,dropUnit:this._dropUnit.bind(this),menuItems:c,ref:'machinesColumn',sendAnalytics:a.sendAnalytics,title:this._generateMachinesTitle(),type:'machine'},this._generateAddMachine(),this._generateMachines()),React.createElement(MachineViewColumn,{acl:g,activeMenuItem:this.state.containerSort,droppable:!!this._getSelected().machine,dropUnit:this._dropUnit.bind(this),menuItems:d,ref:'containersColumn',sendAnalytics:a.sendAnalytics,title:this._generateContainersTitle(),type:'container'},this._generateAddContainer(),this._generateContainers())))}}MachineView.propTypes={acl:shapeup.shape({isReadOnly:PropTypes.func.isRequired,reshape:shapeup.reshapeFunc}).frozen.isRequired,changeState:PropTypes.func.isRequired,dbAPI:shapeup.shape({addGhostAndEcsUnits:PropTypes.func.isRequired,applications:PropTypes.object.isRequired,machines:PropTypes.object.isRequired,modelName:PropTypes.string.isRequired,reshape:shapeup.reshapeFunc,units:PropTypes.object.isRequired}).isRequired,generateMachineDetails:PropTypes.func.isRequired,machine:PropTypes.string.isRequired,modelAPI:shapeup.shape({autoPlaceUnits:PropTypes.func.isRequired,createMachine:PropTypes.func.isRequired,destroyMachines:PropTypes.func.isRequired,placeUnit:PropTypes.func.isRequired,providerType:PropTypes.string,removeUnits:PropTypes.func.isRequired,reshape:shapeup.reshapeFunc,updateMachineConstraints:PropTypes.func.isRequired,updateMachineSeries:PropTypes.func.isRequired}).isRequired,parseConstraints:PropTypes.func.isRequired,parseMachineName:PropTypes.func.isRequired,sendAnalytics:PropTypes.func.isRequired,series:PropTypes.array},module.exports=ReactDnD.DragDropContext(ReactDnDHTML5Backend)(MachineView);