'use strict';const BundleImporter=require('./bundle-importer'),jujulibConversionUtils=require('./jujulib-conversion-utils');describe('BundleImporter',()=>{let a,b,c,d,e,f,g,h;beforeAll((a)=>{YUI(GlobalConfig).use(['juju-tests-utils','juju-models','juju-env-api','juju-tests-factory','environment-change-set'],(b)=>{g=b['juju-tests'].utils,f=b.namespace('juju.models'),h=b,a()})}),beforeEach(()=>{const g=new window.jujugui.User({sessionStorage:(()=>{return new function(){return{store:{},setItem:function(a,b){this.store.name=b},getItem:function(){return this.store.name||null}}}})()});g.controller={user:'user',password:'password'},c=new f.Database({getECS:sinon.stub().returns({changeSet:{}})}),e=new h.juju.environments.GoEnvironment({user:g,ecs:new h.juju.EnvironmentChangeSet({db:c})}),b=h['juju-tests'].factory.makeFakeCharmstore(),d=sinon.stub(),a=new BundleImporter({charmstore:b,db:c,getBundleChanges:d,makeEntityModel:jujulibConversionUtils.makeEntityModel,modelAPI:e})}),afterEach((a)=>{c.destroy(),e.close(()=>{e.destroy(),a()})}),it('can be instantiated',()=>{assert.equal(a instanceof BundleImporter,!0),assert.equal('object'==typeof a.modelAPI,!0),assert.equal('object'==typeof a.db,!0),assert.equal('object'==typeof a.charmstore,!0)}),describe('importBundleYAML',()=>{it('calls fetchDryRun with yaml',()=>{const b=sinon.stub(a,'fetchDryRun'),c=sinon.stub(a.db.notifications,'add');a.importBundleYAML('foo: bar','cs:~foo/bundle/bar'),assert.equal(b.callCount,1);const d=b.lastCall.args;assert.equal(d.length,3),assert.equal(d[0],'foo: bar'),assert.equal(d[1],'cs:~foo/bundle/bar'),assert.strictEqual(d[2],null),assert.equal(c.callCount,1),assert.deepEqual(c.lastCall.args[0],{title:'Fetching bundle data',message:'Fetching detailed bundle data, this may take some time',level:'important'})})}),describe('importBundleFile',()=>{it('sets up and loads the FileReader',()=>{const b=sinon.stub(),c=sinon.stub(a,'_generateFileReader').returns({onload:'',readAsText:b}),d=sinon.stub();a.hideDragOverNotification=d;const e=sinon.stub(a,'_fileReaderOnload'),f=a.importBundleFile('path/to/file');assert.equal(c.callCount,1),assert.equal(b.callCount,1),f.onload(),assert.equal(e.callCount,1),assert.equal(d.callCount,1)}),describe('FileReader onload callback',()=>{it('calls fetchDryRun if yaml file',()=>{const b=sinon.stub(a,'fetchDryRun');a._fileReaderOnload({name:'path/to/file.yaml'},{target:{result:'foo'}}),assert.equal(b.callCount,1);const c=b.lastCall.args;assert.equal(c.length,3),assert.equal(c[0],'foo'),assert.equal(c[1],'path/to/file'),assert.strictEqual(c[2],null)})})}),describe('importBundleDryRun',()=>{const b=[{id:'2',requires:[]},{id:'5',requires:['3']},{id:'6',requires:['2','5']},{id:'4',requires:['2']},{id:'3',requires:[]}],c=[{id:'2',requires:[]},{id:'4',requires:['2']},{id:'3',requires:[]},{id:'5',requires:['3']},{id:'6',requires:['2','5']}];it('sorts the records then calls to execute',()=>{const d=sinon.stub(a,'_executeDryRun');a.importBundleDryRun(b),assert.deepEqual(a.recordSet,c),assert.equal(d.callCount,1),assert.deepEqual(d.lastCall.args[0],c)})}),describe('fetchDryRun',()=>{it('calls to modelAPI to get bundle changes from a YAML',()=>{const b='{"services":{}}';a._handleFetchDryRun=sinon.stub(),a.fetchDryRun(b,'filename',null),assert.equal(d.callCount,1);const c=d.lastCall.args;assert.equal(c.length,3),assert.equal(c[0],b),assert.strictEqual(c[1],null),c[2](),assert.equal(a._handleFetchDryRun.args[0],'filename')}),it('ensures v4 format on import',()=>{a.fetchDryRun('{"bundle":{"services":{}}}','filename',null),assert.equal(d.callCount,1);const b=d.lastCall.args;assert.equal(b.length,3),assert.equal(b[0],'{"services":{}}'),assert.strictEqual(b[1],null)}),it('can import v4 bundles with applications key',()=>{a.fetchDryRun('{"applications":{}}','filename',null),assert.equal(d.callCount,1);const b=d.lastCall.args;assert.equal(b.length,3),assert.equal(b[0],'{"applications":{}}'),assert.strictEqual(b[1],null)}),it('calls to modelAPI to get bundle changes from a token',()=>{const b='foo';a.fetchDryRun(null,'filename',b),assert.equal(d.callCount,1);const c=d.lastCall.args;assert.equal(c.length,3),assert.strictEqual(c[0],null),assert.equal(c[1],b)}),it('has a callback which calls to import the dry run',()=>{const b=sinon.stub(a,'importBundleDryRun'),c=[{foo:'bar'}];a.fetchDryRun('foo','filename');const e=d.lastCall.args[2];e([],c),assert.equal(b.callCount,1),assert.deepEqual(b.lastCall.args[0],c)})}),describe('Changeset generation methods',()=>{it('calls to execute supplied records',()=>{function b(a,b){c[a.method]=!0,b()}const c={addCharm:!1,addMachines:!1,deploy:!1,addUnit:!1,addRelation:!1,setAnnotations:!1};a._execute_addCharm=b,a._execute_addMachines=b,a._execute_deploy=b,a._execute_addUnit=b,a._execute_addRelation=b,a._execute_setAnnotations=b;a._executeDryRun([{method:'addCharm'},{method:'addMachines'},{method:'deploy'},{method:'addUnit'},{method:'addRelation'},{method:'setAnnotations'}]),assert.deepEqual(c,{addCharm:!0,addMachines:!0,deploy:!0,addUnit:!0,addRelation:!0,setAnnotations:!0})}),it('properly sorts a recordSet',()=>{const b=g.loadFixture('data/wordpress-bundle-recordset.json',!0),c=a._sortDryRunRecords(b),d=['addCharm-0','deploy-1','setAnnotations-2','addCharm-3','deploy-4','setAnnotations-5','addCharm-6','deploy-7','expose-8','deploy-99','setAnnotations-9','addMachines-10','addMachines-11','addRelation-11','addRelation-12','addUnit-13','addMachines-16','addUnit-14','addMachines-17','addUnit-15','addUnit-16','addUnit-17'];c.forEach(function(a,b){assert.equal(a.id,d[b])})}),it('stops but does not fail if unknown record type',()=>{const b=sinon.stub(a,'_executeRecord'),c=sinon.stub(a.db.notifications,'add');a._executeDryRun([{method:'badMethod'}]);const d=b.lastCall.args;b.restore(),a._executeRecord.apply(a,d),assert.equal(b.callCount,1,'execute not called'),assert.equal(c.callCount,1,'notification not added')})}),describe('Changeset execution',()=>{it('sets up the correct model (v5 Integration)',(d)=>{let e=0;b.getCanonicalId=(a,b)=>{e+=1,b(null,a)};const f=g.loadFixture('data/wordpress-bundle-recordset.json',!0),h=()=>{document.removeEventListener('topo.bundleImportComplete',h),assert.equal(a._dryRunIndex,-1),assert.equal(c.services.size(),4),assert.equal(c.units.size(),5),assert.equal(c.machines.size(),5),assert.equal(c.relations.size(),2),assert.equal(c.charms.item(0).loaded,!0),assert.equal(c.services.item(0).get('charm'),'cs:precise/haproxy-35'),assert.equal(c.services.item(0).get('config').default_retries,42),assert.equal(c.units.item(0).service,c.services.item(0).get('id')),assert.equal(c.units.item(0).displayName,'haproxy/0'),assert.equal(c.services.item(1).get('charm'),'cs:precise/wordpress-27'),assert.equal(c.units.item(1).service,c.services.item(1).get('id')),assert.equal(c.units.item(1).displayName,'wordpress/0'),assert.equal(c.services.item(2).get('charm'),'cs:precise/mysql-51'),assert.equal(c.units.item(2).service,c.services.item(2).get('id')),assert.equal(c.units.item(2).displayName,'mysql/0'),assert.equal(c.services.item(3).get('charm'),'cs:precise/mysql-51'),assert.equal(c.services.item(3).get('name'),'mysql-slave'),assert.equal(c.services.item(3).get('displayName'),'(mysql-slave)'),assert.equal(c.machines.item(0).id,'new0'),assert.equal(c.machines.item(1).id,'new1'),assert.equal(c.machines.item(2).id,'new4'),assert.equal(c.machines.item(3).id,'new0/lxd/new3'),assert.equal(c.machines.item(4).id,'new1/lxd/new2');const b=[c.services.item(0).get('id'),c.services.item(1).get('id'),c.services.item(2).get('id')];assert.equal(c.relations.item(0).get('id'),`pending-$deploy-1:reverseproxy${b[0]}$deploy-4:website${b[1]}`),assert.equal(c.relations.item(1).get('id'),`pending-$deploy-4:db${b[1]}$deploy-7:db${b[2]}`),assert.equal(c.services.item(0).get('exposed'),!1),assert.equal(c.services.item(1).get('exposed'),!1),assert.equal(c.services.item(2).get('exposed'),!0),assert.equal(c.services.item(3).get('exposed'),!1),assert.equal(e,3),d()};document.addEventListener('topo.bundleImportComplete',h),a.importBundleDryRun(f)}),it('handles conflicts with existing service names',(b)=>{c.services.add(new h.juju.models.Service({id:'haproxy',charm:'cs:precise/haproxy-35'}));const d=g.loadFixture('data/wordpress-bundle-recordset.json',!0),e=()=>{document.removeEventListener('topo.bundleImportComplete',e),assert.equal(c.services.item(0).get('name'),'haproxy'),assert.equal(c.services.item(1).get('name'),'haproxy-a'),b()};document.addEventListener('topo.bundleImportComplete',e),a.importBundleDryRun(d)}),it('sets up the correct model (v3 colocation)',()=>{const b=g.loadFixture('data/wordpress-bundle-v3-recordset.json',!0);a.importBundleDryRun(b),assert.equal(c.services.size(),2,'incorrect number of services'),assert.equal(c.units.size(),2,'incorrect number of units'),assert.equal(c.machines.size(),1,'incorrect number of machines'),assert.equal(c.units.item(0).machine,c.units.item(1).machine)})}),describe('_execute_deploy',()=>{it('properly merges bundle config with defaults',()=>{const c='cs:trusty/haproxy-10',d='haproxy',e={options:{services:{default:'foo',description:'',type:'string'},enable_monitoring:{default:!1,description:'',type:'boolean'},source:{default:'',description:'',type:'string'},default_log:{default:'global',description:'',type:'string'}},id:c,series:'trusty'},g=sinon.stub();b.getEntity=(a,b)=>{b(null,[e])},a.modelAPI.deploy=sinon.stub();const h=new f.Service({id:c,name:d});a.db.services.ghostService=sinon.stub(),a.db.services.ghostService.returns(h),a._saveModelToRequires=sinon.stub(),a._execute_deploy({"addCharm-0":{},args:[c,'trusty',d,{services:'',enable_monitoring:!0,source:'backports'},'',{},{},{}],id:'deploy-1',method:'deploy',requires:['addCharm-0']},g);const i=h.get('config');assert.deepEqual(i,{services:'',enable_monitoring:!0,source:'backports',default_log:'global'})})})});