'use strict';chai.config.includeStack=!0,chai.config.truncateThreshold=0,describe('jujulib plans service',function(){const a=function(a){return{target:{responseText:JSON.stringify(a)}}};it('exists',function(){const a=new window.jujulib.plans('http://1.2.3.4/',{});assert.strictEqual(a instanceof window.jujulib.plans,!0),assert.strictEqual(a.url,'http://1.2.3.4/'+window.jujulib.plansAPIVersion)}),it('is smart enough to handle missing trailing slash in URL',function(){const a=new window.jujulib.plans('http://1.2.3.4',{});assert.strictEqual(a.url,'http://1.2.3.4/'+window.jujulib.plansAPIVersion)}),it('lists plans for a charm',function(b){const c=new window.jujulib.plans('http://1.2.3.4/',{get:function(b,c,d){assert.equal(b,'http://1.2.3.4/'+window.jujulib.plansAPIVersion+'/charm?charm-url=cs:juju-gui-42');const e=a([{url:'canonical-landscape/24-7',plan:'1',"created-on":'2016-06-09T22:07:24Z',description:'Delivers the highest level of support.',model:{metrics:'metric'},price:'the/price'},{url:'canonical-landscape/8-5',plan:'B',"created-on":'2016-06-09T22:07:24Z',description:'Offers a high level of support.',model:{metrics:'metric'},price:'the/price'},{url:'canonical-landscape/free',plan:'9 from outer space',"created-on":'2015-06-09T22:07:24Z',description:'No support available.',model:{metrics:'metric'},price:'Free'}]);d(null,e)}});c.listPlansForCharm('cs:juju-gui-42',function(a,c){assert.isNull(a),assert.deepEqual(c,[{url:'canonical-landscape/24-7',yaml:'1',createdAt:new Date(1465510044000),description:'Delivers the highest level of support.',metrics:'metric',price:'the/price'},{url:'canonical-landscape/8-5',yaml:'B',createdAt:new Date(1465510044000),description:'Offers a high level of support.',metrics:'metric',price:'the/price'},{url:'canonical-landscape/free',yaml:'9 from outer space',createdAt:new Date(1433887644000),description:'No support available.',metrics:'metric',price:'Free'}]),b()})}),it('adds the charm schema prefix when listing plans',function(b){const c=new window.jujulib.plans('http://1.2.3.4/',{get:function(b,c,d){assert.equal(b,'http://1.2.3.4/'+window.jujulib.plansAPIVersion+'/charm?charm-url=cs:django');const e=a([]);d(null,e)}});c.listPlansForCharm('django',function(a){assert.isNull(a),b()})}),it('handles missing plans',function(b){const c=new window.jujulib.plans('http://1.2.3.4/',{get:function(b,c,d){const e=a([]);d(null,e)}});c.listPlansForCharm('cs:juju-gui/42',function(a,c){assert.isNull(a),assert.deepEqual(c,[]),b()})}),it('handles errors listing plans',function(b){const c=new window.jujulib.plans('http://1.2.3.4/',{get:function(b,c,d){const e=a({error:'bad wolf'});d(null,e)}});c.listPlansForCharm('django',function(a,c){assert.equal(a,'bad wolf'),assert.isNull(c),b()})}),it('retrieves the active plan for a given model and app',function(b){const c=new window.jujulib.plans('http://1.2.3.4/',{get:function(b,c,d){assert.equal(b,'http://1.2.3.4/'+window.jujulib.plansAPIVersion+'/plan/model/uuid/service/app-name');const e=a({"current-plan":'canonical-landscape/free',"available-plans":{"canonical-landscape/8-5":{url:'canonical-landscape/8-5',plan:'B',"created-on":'2016-06-09T22:07:24Z',description:'Offers a high level of support.',model:{metrics:'metric'},price:'the/price'},"canonical-landscape/free":{url:'canonical-landscape/free',plan:'9 from outer space',"created-on":'2015-06-09T22:07:24Z',description:'No support available.',model:{metrics:'metric'},price:'Free'}}});d(null,e)}});c.showActivePlan('uuid','app-name',function(a,c,d){assert.isNull(a),assert.deepEqual(c,{url:'canonical-landscape/free',yaml:'9 from outer space',createdAt:new Date(1433887644000),description:'No support available.',metrics:'metric',price:'Free'}),assert.deepEqual(d,[{url:'canonical-landscape/8-5',yaml:'B',createdAt:new Date(1465510044000),description:'Offers a high level of support.',metrics:'metric',price:'the/price'},{url:'canonical-landscape/free',yaml:'9 from outer space',createdAt:new Date(1433887644000),description:'No support available.',metrics:'metric',price:'Free'}]),b()})}),it('does not request active plans if no modelUUID is provided',function(){const a=new window.jujulib.plans('http://1.2.3.4/',{get:function(){assert.fail('request should not have been made')}});a.showActivePlan(void 0,'app-name',()=>{})}),it('handles errors retrieving the currently active plan',function(b){const c=new window.jujulib.plans('http://1.2.3.4/',{get:function(b,c,d){const e=a({error:'bad wolf'});d(null,e)}});c.showActivePlan('uuid','app-name',function(a,c,d){assert.equal(a,'bad wolf'),assert.isNull(c),assert.deepEqual(d,[]),b()})}),it('handles authorizing a plan',function(b){const c=new window.jujulib.plans('http://1.2.3.4/',{post:function(b,c,d,e){assert.equal(b,'http://1.2.3.4/'+window.jujulib.plansAPIVersion+'/plan/authorize');const f=a({"look ma":'I\'m a macaroon',params:d});e(null,f)}});c.authorizePlan('envUUID','charmUrl','applicationName','planUrl','budget','limit',function(a,c){assert.isNull(a),assert.equal(c['look ma'],'I\'m a macaroon'),assert.equal(c.params,'{"env-uuid":"envUUID","charm-url":"charmUrl","service-name":"applicationName","plan-url":"planUrl","budget":"budget","limit":"limit"}'),b()})}),it('lists budgets',function(b){const c={budgets:[{owner:'spinach',budget:'my-budget',limit:99,allocated:77,unallocated:22,available:22,consumed:55}],total:{limit:999,allocated:777,unallocated:222,consumed:55,available:22}},d=new window.jujulib.plans('http://1.2.3.4/',{get:function(b,d,e){assert.equal(b,'http://1.2.3.4/'+window.jujulib.plansAPIVersion+'/budget');const f=a(c);e(null,f)}});d.listBudgets(function(a,d){assert.isNull(a),assert.deepEqual(d,c),b()})}),it('handles errors listing budgets',function(b){const c=new window.jujulib.plans('http://1.2.3.4/',{get:function(b,c,d){const e=a({error:'bad wolf'});d(null,e)}});c.listBudgets(function(a,c){assert.equal(a,'bad wolf'),assert.isNull(c),b()})}),it('handles adding a budget',function(b){const c=new window.jujulib.plans('http://1.2.3.4/',{post:function(b,c,d,e){assert.equal(b,'http://1.2.3.4/'+window.jujulib.plansAPIVersion+'/budget');const f=a({auth:'I\'m a macaroon',params:d});e(null,f)}});c.createBudget('budget','limit',function(a,c){assert.isNull(a),assert.equal(c.auth,'I\'m a macaroon'),assert.equal(c.params,'{"budget":"budget","limit":"limit"}'),b()})}),it('handles errors when adding a budget',function(b){const c=new window.jujulib.plans('http://1.2.3.4/',{post:function(b,c,d,e){assert.equal(b,'http://1.2.3.4/'+window.jujulib.plansAPIVersion+'/budget');const f=a({error:'bad wolf'});e(null,f)}});c.createBudget('budget','limit',function(a){assert.equal(a,'bad wolf'),b()})}),it('requests to update a budget',function(b){const c=new window.jujulib.plans('http://1.2.3.4/',{patch:function(b,c,d,e){assert.equal(b,'http://1.2.3.4/'+window.jujulib.plansAPIVersion+'/budget/budgetid'),assert.equal(d,'{"limit":"limit"}');const f=a({data:'data'});e(null,f)}});c.updateBudget('budgetid','limit',function(a,c){assert.strictEqual(a,null),assert.deepEqual(c,{data:'data'}),b()})}),it('requests to remove a budget',function(b){const c=new window.jujulib.plans('http://1.2.3.4/',{delete:function(b,c,d,e){assert.equal(b,'http://1.2.3.4/'+window.jujulib.plansAPIVersion+'/budget/budgetid');const f=a({data:'data'});e(null,f)}});c.removeBudget('budgetid',function(a,c){assert.strictEqual(a,null),assert.deepEqual(c,{data:'data'}),b()})}),it('requests to create an allocation',function(b){const c=new window.jujulib.plans('http://1.2.3.4/',{post:function(b,c,d,e){assert.equal(b,'http://1.2.3.4/'+window.jujulib.plansAPIVersion+'/budget/budgetid/allocation'),assert.deepEqual(d,'{"services":["application"],"model":"model","limit":"limit"}');const f=a({data:'data'});e(null,f)}});c.createAllocation('budgetid','application','model','limit',function(a,c){assert.strictEqual(a,null),assert.deepEqual(c,{data:'data'}),b()})}),it('requests to update allocations',function(b){const c=new window.jujulib.plans('http://1.2.3.4/',{patch:function(b,c,d,e){assert.equal(b,'http://1.2.3.4/'+window.jujulib.plansAPIVersion+'/model/model/service/application/allocation'),assert.deepEqual(d,'{"limit":"limit"}');const f=a({data:'data'});e(null,f)}});c.updateAllocation('model','application','limit',function(a,c){assert.strictEqual(a,null),assert.deepEqual(c,{data:'data'}),b()})}),it('requests to remove allocations',function(b){const c=new window.jujulib.plans('http://1.2.3.4/',{delete:function(b,c,d,e){assert.equal(b,'http://1.2.3.4/'+window.jujulib.plansAPIVersion+'/environment/model/service/application/allocation');const f=a({data:'data'});e(null,f)}});c.removeAllocation('application','model',function(a,c){assert.strictEqual(a,null),assert.deepEqual(c,{data:'data'}),b()})}),it('requests to update credit limits',function(b){const c=new window.jujulib.plans('http://1.2.3.4/',{patch:function(b,c,d,e){assert.equal(b,'http://1.2.3.4/'+window.jujulib.plansAPIVersion+'/profile/user'),assert.deepEqual(d,'{"update":{"limit":"limit"}}');const f=a({data:'data'});e(null,f)}});c.updateCreditLimit('user','limit',function(a,c){assert.strictEqual(a,null),assert.deepEqual(c,{data:'data'}),b()})}),it('requests to update default budget',function(b){const c=new window.jujulib.plans('http://1.2.3.4/',{patch:function(b,c,d,e){assert.equal(b,'http://1.2.3.4/'+window.jujulib.plansAPIVersion+'/profile'),assert.deepEqual(d,'{"update":{"default-budget":"defaultBudget"}}');const f=a({data:'data'});e(null,f)}});c.updateDefaultBudget('defaultBudget',function(a,c){assert.strictEqual(a,null),assert.deepEqual(c,{data:'data'}),b()})}),it('gets budget details',function(b){const c={limit:'budget limit',total:{allocated:'total allocated amount',available:'unconsumed amount',unallocated:'unallocated amount',usage:'percentage of budget consumed',consumed:'total consumed amount'},allocations:[{owner:'user, creator of allocation',consumed:'amount consumed',limit:'allocation limit',usage:'consumed/limit',model:'model uuid',services:{"service name":{consumed:'consumed',usage:'consumed/allocation limit'}}}]},d=new window.jujulib.plans('http://1.2.3.4/',{get:function(b,d,e){assert.equal(b,'http://1.2.3.4/'+window.jujulib.plansAPIVersion+'/budget/my-budget');const f=a(c);e(null,f)}});d.showBudget('my-budget',function(a,d){assert.isNull(a),assert.deepEqual(d,c),b()})}),it('handles errors listing budgets',function(b){const c=new window.jujulib.plans('http://1.2.3.4/',{get:function(b,c,d){const e=a({error:'bad wolf'});d(null,e)}});c.showBudget('my-budget',function(a,c){assert.equal(a,'bad wolf'),assert.isNull(c),b()})}),it('handles adding a profile',function(b){const c=new window.jujulib.plans('http://1.2.3.4/',{post:function(b,c,d,e){assert.equal(b,'http://1.2.3.4/'+window.jujulib.plansAPIVersion+'/profile');const f=a({auth:'I\'m a macaroon',response:'profile saved'});e(null,f)}});c.createProfile('user','limit','default-budget','default-budget-limit',function(a,c){assert.isNull(a),assert.equal(c.auth,'I\'m a macaroon'),assert.equal(c.response,'profile saved'),b()})}),it('handles errors when adding a budget',function(b){const c=new window.jujulib.plans('http://1.2.3.4/',{post:function(b,c,d,e){assert.equal(b,'http://1.2.3.4/'+window.jujulib.plansAPIVersion+'/profile');const f=a({error:'bad wolf'});e(null,f)}});c.createProfile('user','limit','default-budget','default-budget-limit',function(a){assert.equal(a,'bad wolf'),b()})}),it('gets kpi metrics for a charm',function(b){const c=new window.jujulib.plans('http://1.2.3.4/',{get:function(b,c,d){assert.equal(b,'http://1.2.3.4/'+window.jujulib.plansAPIVersion+'/metrics/kpi?charm-url=cs%3Ajuju-gui-42');const e=a([{Metric:'metric',Time:'t',Sum:42,Count:5,Min:'min',Max:'max'},{Metric:'bad-wolf',Time:'t',Sum:53,Count:8,Min:'min',Max:'max'},{Metric:'metric',Time:'t',Sum:80,Count:10,Min:'min',Max:'max'}]);d(null,e)}});c.getKpiMetrics('cs:juju-gui-42',{},function(a,c){assert.isNull(a),assert.deepEqual(c,[{metric:'metric',time:'t',sum:42,count:5,min:'min',max:'max'},{metric:'bad-wolf',time:'t',sum:53,count:8,min:'min',max:'max'},{metric:'metric',time:'t',sum:80,count:10,min:'min',max:'max'}]),b()})})});